#ifndef Testing_Ogre_H
#define Testing_Ogre_H

#include "ExampleApplication.h"

class OceanDemoTest_FrameListener : public ExampleFrameListener
{
public:
    bool frameStarted(const Ogre::FrameEvent& evt)
    {
    }
};

//---------------------------------------------------------------------------
class OceanDemoTest : public ExampleApplication
{
protected:
    Ogre::Entity*         mOceanSurfaceEnt;

    void createScene(void)
    {
        // Define a plane mesh that will be used for the ocean surface
		mSceneMgr->setSkyBox(true, "SkyBox", 1000);

        Ogre::Plane oceanSurface;
        oceanSurface.normal = Ogre::Vector3::UNIT_Y;
        oceanSurface.d = 20;
        Ogre::MeshManager::getSingleton().createPlane("OceanSurface",
            Ogre::ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME,
            oceanSurface,
            1000, 1000, 50, 50, true, 1, 1, 1, Ogre::Vector3::UNIT_Z);

        mOceanSurfaceEnt = mSceneMgr->createEntity( "OceanSurface", "OceanSurface" );
        mSceneMgr->getRootSceneNode()->createChildSceneNode()->attachObject(mOceanSurfaceEnt);

		mOceanSurfaceEnt->setMaterialName("OceanTest_Cg");
    }

};

#endif  // end _OceanDemoTest_H_
